## net.sf.saxon.expr
Class AtomicSequenceConverter

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.UnaryExpression
              net.sf.saxon.expr.AtomicSequenceConverter

All Implemented Interfaces:
  Serializable, SourceLocator, LocationProvider, SaxonLocator, EvaluableItem, SequenceIterable, InstructionInfo, Locator

    public final class AtomicSequenceConverter

extends UnaryExpression

An AtomicSequenceConverter is an expression that performs a cast on each member of a supplied sequence

See Also:
  Serialized Form

Nested Class Summary
`static class` `AtomicSequenceConverter.AtomicSequenceMappingFunction`

Field Summary

Fields inherited from class net.sf.saxon.expr.UnaryExpression
`operand`

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, EVENT_FEED_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, PROCESS_METHOD, PUSH_SELECTION, staticProperties, WATCH_METHOD`

Constructor Summary
`AtomicSequenceConverter(Expression sequence, AtomicType requiredItemType)` Constructor

Method Summary
`int` `computeCardinality()` Determine the static cardinality of the expression
`int` `computeSpecialProperties()` Determine the special properties of this expression
`Expression` `copy()` Copy an expression.
`boolean` `equals(Object other)` Is this expression the same as another expression?
`Item` `evaluateItem(XPathContext context)` Evaluate as an Item.
`void` `explain(ExpressionPresenter destination)` Diagnostic print of expression structure.
`ItemType` `getItemType(TypeHierarchy th)` Determine the data type of the items returned by the expression, if possible
`BuiltInAtomicType` `getRequiredPrimitiveType()` Get the required (target) primitive type
`int` `hashCode()` get HashCode for comparing two expressions.
`SequenceIterator` `iterate(XPathContext context)` Iterate over the sequence of values
`Expression` `simplify(ExpressionVisitor visitor)` Simplify an expression
`Expression` `typeCheck(ExpressionVisitor visitor, ItemType contextItemType)` Type-check the expression

Methods inherited from class net.sf.saxon.expr.UnaryExpression
`displayOperator, getBaseExpression, iterateSubExpressions, optimize, promote, replaceSubExpression, toString`

Methods inherited from class net.sf.saxon.expr.Expression

`addToPathMap, adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, dynamicError, effectiveBooleanValue, evaluateAsString, evaluatePendingUpdates, explain, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getEvaluationMethod, getExecutable, getExpressionName, getHostLanguage, getImplementationMethod, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasLoopingSubexpression, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterateEvents, iterateSameFocusSubExpressions, markTailFunctionCalls, process, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### AtomicSequenceConverter

    public AtomicSequenceConverter(Expression sequence,
                                   AtomicType requiredItemType)

  Constructor

  Parameters:
    `sequence` - this must be a sequence of atomic values. This is not checked; a ClassCastException will occur if the precondition is not satisfied.
    `requiredItemType` - the item type to which all items in the sequence should be converted, using the rules for "cast as".

Method Detail

### getRequiredPrimitiveType

    public BuiltInAtomicType getRequiredPrimitiveType()

  Get the required (target) primitive type

  Returns:
    the required primitive type

### simplify

    public Expression simplify(ExpressionVisitor visitor)
                        throws XPathException

  Simplify an expression

  Overrides:
    `simplify` in class `UnaryExpression`
  Parameters:
    `visitor` - an expression visitor
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### typeCheck

    public Expression typeCheck(ExpressionVisitor visitor,
                                ItemType contextItemType)
                         throws XPathException

  Type-check the expression

  Overrides:
    `typeCheck` in class `UnaryExpression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### computeSpecialProperties

    public int computeSpecialProperties()

  Determine the special properties of this expression

  Overrides:
    `computeSpecialProperties` in class `UnaryExpression`
  Returns:
    `StaticProperty.NON_CREATIVE`.

### copy

    public Expression copy()

  Copy an expression. This makes a deep copy.

  Specified by:
    `copy` in class `Expression`
  Returns:
    the copy of the original expression

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Iterate over the sequence of values

  Specified by:
    `iterate` in interface `SequenceIterable`
  Overrides:
    `iterate` in class `Expression`
  Parameters:
    `context` - supplies the context for evaluation
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate as an Item. This should only be called if the AtomicSequenceConverter has cardinality zero-or-one

  Specified by:
    `evaluateItem` in interface `EvaluableItem`
  Overrides:
    `evaluateItem` in class `Expression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Determine the data type of the items returned by the expression, if possible

  Overrides:
    `getItemType` in class `UnaryExpression`
  Parameters:
    `th` - the type hierarchy cache
  Returns:
    a value such as Type.STRING, Type.BOOLEAN, Type.NUMBER, Type.NODE, or Type.ITEM (meaning not known in advance)

### computeCardinality

    public int computeCardinality()

  Determine the static cardinality of the expression

  Overrides:
    `computeCardinality` in class `UnaryExpression`
  Returns:
    the computed cardinality, as one of the values `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`

### equals

    public boolean equals(Object other)

  Is this expression the same as another expression?

  Overrides:
    `equals` in class `UnaryExpression`

### hashCode

    public int hashCode()

  get HashCode for comparing two expressions. Note that this hashcode gives the same result for (A op B) and for (B op A), whether or not the operator is commutative.

  Overrides:
    `hashCode` in class `UnaryExpression`

### explain

    public void explain(ExpressionPresenter destination)

  Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.

  Overrides:
    `explain` in class `UnaryExpression`
  Parameters:
    `destination` - the expression presenter used to display the structure

Copyright (c) 2004-2010 Saxonica Limited. All rights reserved.